Apache NiFi REST API

REST API definition for Apache NiFi web services
More information: https://nifi.apache.org
Contact Info: dev@nifi.apache.org
Version: 2.9.0
Apache 2.0
https://www.apache.org/licenses/LICENSE-2.0.html

Access

  1. HTTP Authorization header with Bearer scheme and JSON Web Token
  2. HTTP session cookie named __Secure-Authorization-Bearer with JSON Web Token

Methods

[ Jump to Models ]

Table of Contents

Access

Authentication

Connections

Connectors

Controller

ControllerServices

Counters

DataTransfer

Flow

FlowFileQueues

Funnels

InputPorts

Labels

OutputPorts

ParameterContexts

ParameterProviders

Policies

ProcessGroups

Processors

Provenance

ProvenanceEvents

RemoteProcessGroups

ReportingTasks

Resources

SiteToSite

Snippets

SystemDiagnostics

Tenants

Versions

Access

Up
post /access/token
Creates a token for accessing the REST API via username/password (createAccessToken)
The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. It is stored in the browser as a cookie, but also returned inthe response body to be stored/used by third party client scripts.

Consumes

This API call consumes the following media types via the Content-Type request header:

Form parameters

password (optional)
Form Parameter
username (optional)
Form Parameter

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

String

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

500

Unable to create access token because an unexpected error occurred.

Up
delete /access/logout
Performs a logout for other providers that have been issued a JWT. (logOut)
Note: This endpoint is subject to change as NiFi and it's REST API evolve.

Query parameters

Responses

200

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Up
get /access/logout/complete
Completes the logout sequence by removing the cached Logout Request and Cookie if they existed and redirects to /nifi/login. (logOutComplete)
Note: This endpoint is subject to change as NiFi and it's REST API evolve.

Query parameters

Responses

302

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Authentication

Up
get /authentication/configuration
Retrieves the authentication configuration details and status information (getAuthenticationConfiguration)

Return type

AuthenticationConfigurationEntity

Example data

Content-Type: application/json
{
  "authenticationConfiguration" : {
    "logoutUri" : "logoutUri",
    "loginUri" : "loginUri",
    "externalLoginRequired" : true,
    "loginSupported" : true
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

AuthenticationConfigurationEntity

Connections

Up
delete /connections/{id}
Deletes a connection (deleteConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 3,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  }, {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  } ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "loadBalanceCompression",
    "destination" : {
      "running" : true,
      "comments" : "comments",
      "groupId" : "groupId",
      "versionedComponentId" : "versionedComponentId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR"
    },
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "loadBalanceStrategy",
    "parentGroupId" : "parentGroupId",
    "labelIndex" : 7,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "loadBalanceStatus",
    "backPressureObjectThreshold" : 5,
    "getzIndex" : 2,
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "id" : "id",
    "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR",
  "id" : "id",
  "sourceGroupId" : "sourceGroupId",
  "status" : {
    "sourceId" : "sourceId",
    "destinationName" : "destinationName",
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 1,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 4,
        "predictionIntervalSeconds" : 9,
        "predictedPercentBytes" : 6,
        "predictedPercentCount" : 8,
        "predictedMillisUntilCountBackpressure" : 9,
        "predictedCountAtNextInterval" : 5,
        "predictedMillisUntilBytesBackpressure" : 9
      },
      "output" : "output",
      "input" : "input",
      "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED",
      "percentUseBytes" : 7,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesQueued" : 6,
      "name" : "name",
      "flowFilesIn" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesOut" : 1,
      "bytesIn" : 4,
      "bytesOut" : 7,
      "bytesQueued" : 1
    },
    "id" : "id",
    "sourceName" : "sourceName",
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
get /connections/{id}
Gets a connection (getConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Query parameters

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 3,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  }, {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  } ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "loadBalanceCompression",
    "destination" : {
      "running" : true,
      "comments" : "comments",
      "groupId" : "groupId",
      "versionedComponentId" : "versionedComponentId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR"
    },
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "loadBalanceStrategy",
    "parentGroupId" : "parentGroupId",
    "labelIndex" : 7,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "loadBalanceStatus",
    "backPressureObjectThreshold" : 5,
    "getzIndex" : 2,
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "id" : "id",
    "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR",
  "id" : "id",
  "sourceGroupId" : "sourceGroupId",
  "status" : {
    "sourceId" : "sourceId",
    "destinationName" : "destinationName",
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 1,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 4,
        "predictionIntervalSeconds" : 9,
        "predictedPercentBytes" : 6,
        "predictedPercentCount" : 8,
        "predictedMillisUntilCountBackpressure" : 9,
        "predictedCountAtNextInterval" : 5,
        "predictedMillisUntilBytesBackpressure" : 9
      },
      "output" : "output",
      "input" : "input",
      "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED",
      "percentUseBytes" : 7,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesQueued" : 6,
      "name" : "name",
      "flowFilesIn" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesOut" : 1,
      "bytesIn" : 4,
      "bytesOut" : 7,
      "bytesQueued" : 1
    },
    "id" : "id",
    "sourceName" : "sourceName",
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
put /connections/{id}
Updates a connection (updateConnection)

Path parameters

id (required)
Path Parameter — The connection id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ConnectionEntity (required)
Body Parameter — The connection configuration details.

Query parameters

Return type

ConnectionEntity

Example data

Content-Type: application/json
{
  "sourceId" : "sourceId",
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "destinationGroupId" : "destinationGroupId",
  "labelIndex" : 3,
  "destinationId" : "destinationId",
  "uri" : "uri",
  "bends" : [ {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  }, {
    "x" : 0.8008281904610115,
    "y" : 6.027456183070403
  } ],
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "prioritizers" : [ "prioritizers", "prioritizers" ],
    "flowFileExpiration" : "flowFileExpiration",
    "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
    "loadBalanceCompression" : "loadBalanceCompression",
    "destination" : {
      "running" : true,
      "comments" : "comments",
      "groupId" : "groupId",
      "versionedComponentId" : "versionedComponentId",
      "name" : "name",
      "transmitting" : true,
      "exists" : true,
      "id" : "id",
      "type" : "PROCESSOR"
    },
    "availableRelationships" : [ "availableRelationships", "availableRelationships" ],
    "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
    "loadBalanceStrategy" : "loadBalanceStrategy",
    "parentGroupId" : "parentGroupId",
    "labelIndex" : 7,
    "bends" : [ null, null ],
    "loadBalanceStatus" : "loadBalanceStatus",
    "backPressureObjectThreshold" : 5,
    "getzIndex" : 2,
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "id" : "id",
    "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
    "loadBalancePartitionAttribute" : "loadBalancePartitionAttribute"
  },
  "sourceType" : "PROCESSOR",
  "permissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "getzIndex" : 9,
  "destinationType" : "PROCESSOR",
  "id" : "id",
  "sourceGroupId" : "sourceGroupId",
  "status" : {
    "sourceId" : "sourceId",
    "destinationName" : "destinationName",
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "sourceId" : "sourceId",
      "groupId" : "groupId",
      "queued" : "queued",
      "percentUseCount" : 1,
      "destinationId" : "destinationId",
      "predictions" : {
        "predictedBytesAtNextInterval" : 4,
        "predictionIntervalSeconds" : 9,
        "predictedPercentBytes" : 6,
        "predictedPercentCount" : 8,
        "predictedMillisUntilCountBackpressure" : 9,
        "predictedCountAtNextInterval" : 5,
        "predictedMillisUntilBytesBackpressure" : 9
      },
      "output" : "output",
      "input" : "input",
      "loadBalanceStatus" : "LOAD_BALANCE_NOT_CONFIGURED",
      "percentUseBytes" : 7,
      "flowFileAvailability" : "flowFileAvailability",
      "destinationName" : "destinationName",
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesQueued" : 6,
      "name" : "name",
      "flowFilesIn" : 1,
      "id" : "id",
      "sourceName" : "sourceName",
      "flowFilesOut" : 1,
      "bytesIn" : 4,
      "bytesOut" : 7,
      "bytesQueued" : 1
    },
    "id" : "id",
    "sourceName" : "sourceName",
    "destinationId" : "destinationId",
    "statsLastRefreshed" : "statsLastRefreshed"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectionEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Connectors

Up
post /connectors/{id}/apply-update
Applies an update to a connector (applyConnectorUpdate)
This will apply any pending configuration changes to the connector. The client can poll the connector endpoint to check when the update is complete.

Path parameters

id (required)
Path Parameter — The connector id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ConnectorEntity (required)
Body Parameter — The connector configuration with revision.

Query parameters

Return type

ConnectorEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "availableActions" : [ {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    }, {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    } ],
    "configurationUrl" : "configurationUrl",
    "detailsUrl" : "detailsUrl",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "activeConfiguration" : {
      "configurationStepConfigurations" : [ {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      }, {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      } ]
    },
    "type" : "type",
    "managedProcessGroupId" : "managedProcessGroupId",
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "position" : {
      "x" : 0.8008281904610115,
      "y" : 6.027456183070403
    },
    "state" : "RUNNING",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "validationStatus"
  },
  "id" : "id",
  "uri" : "uri",
  "operatePermissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "status" : {
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "idleDuration" : "idleDuration",
      "groupId" : "groupId",
      "queued" : "queued",
      "idleDurationMillis" : 2,
      "type" : "type",
      "flowFilesReceived" : 9,
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesSent" : 3,
      "id" : "id",
      "written" : "written",
      "runStatus" : "runStatus",
      "bytesQueued" : 6,
      "bytesWritten" : 2,
      "read" : "read",
      "activeThreadCount" : 0,
      "idle" : true,
      "bytesRead" : 1,
      "processingPerformanceStatus" : {
        "identifier" : "identifier",
        "cpuDuration" : 1,
        "contentReadDuration" : 4,
        "sessionCommitDuration" : 1,
        "garbageCollectionDuration" : 1,
        "contentWriteDuration" : 7
      },
      "received" : "received",
      "bytesSent" : 5,
      "sent" : "sent",
      "bytesReceived" : 5,
      "flowFilesQueued" : 7,
      "name" : "name"
    },
    "id" : "id",
    "type" : "type",
    "statsLastRefreshed" : "statsLastRefreshed",
    "validationStatus" : "VALID",
    "runStatus" : "runStatus"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectorEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /connectors/{id}/drain
Cancels the draining of FlowFiles for a connector (cancelDrain)

Path parameters

id (required)
Path Parameter — The connector id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

ConnectorEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "availableActions" : [ {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    }, {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    } ],
    "configurationUrl" : "configurationUrl",
    "detailsUrl" : "detailsUrl",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "activeConfiguration" : {
      "configurationStepConfigurations" : [ {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      }, {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      } ]
    },
    "type" : "type",
    "managedProcessGroupId" : "managedProcessGroupId",
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "position" : {
      "x" : 0.8008281904610115,
      "y" : 6.027456183070403
    },
    "state" : "RUNNING",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "validationStatus"
  },
  "id" : "id",
  "uri" : "uri",
  "operatePermissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "status" : {
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "idleDuration" : "idleDuration",
      "groupId" : "groupId",
      "queued" : "queued",
      "idleDurationMillis" : 2,
      "type" : "type",
      "flowFilesReceived" : 9,
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesSent" : 3,
      "id" : "id",
      "written" : "written",
      "runStatus" : "runStatus",
      "bytesQueued" : 6,
      "bytesWritten" : 2,
      "read" : "read",
      "activeThreadCount" : 0,
      "idle" : true,
      "bytesRead" : 1,
      "processingPerformanceStatus" : {
        "identifier" : "identifier",
        "cpuDuration" : 1,
        "contentReadDuration" : 4,
        "sessionCommitDuration" : 1,
        "garbageCollectionDuration" : 1,
        "contentWriteDuration" : 7
      },
      "received" : "received",
      "bytesSent" : 5,
      "sent" : "sent",
      "bytesReceived" : 5,
      "flowFilesQueued" : 7,
      "name" : "name"
    },
    "id" : "id",
    "type" : "type",
    "statsLastRefreshed" : "statsLastRefreshed",
    "validationStatus" : "VALID",
    "runStatus" : "runStatus"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectorEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /connectors/{id}/controller-services/{controllerServiceId}/state/clear-requests
Clears the state for a controller service within a connector (clearConnectorControllerServiceState)

Path parameters

id (required)
Path Parameter — The connector id.
controllerServiceId (required)
Path Parameter — The controller service id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ComponentStateEntity (optional)
Body Parameter — Optional component state to perform a selective key removal. If omitted, clears all state.

Query parameters

Return type

ComponentStateEntity

Example data

Content-Type: application/json
{
  "componentState" : {
    "componentId" : "componentId",
    "dropStateKeySupported" : true,
    "stateDescription" : "stateDescription",
    "clusterState" : {
      "totalEntryCount" : 0,
      "scope" : "scope",
      "state" : [ {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      }, {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ComponentStateEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /connectors/{id}/processors/{processorId}/state/clear-requests
Clears the state for a processor within a connector (clearConnectorProcessorState)

Path parameters

id (required)
Path Parameter — The connector id.
processorId (required)
Path Parameter — The processor id.

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ComponentStateEntity (optional)
Body Parameter — Optional component state to perform a selective key removal. If omitted, clears all state.

Query parameters

Return type

ComponentStateEntity

Example data

Content-Type: application/json
{
  "componentState" : {
    "componentId" : "componentId",
    "dropStateKeySupported" : true,
    "stateDescription" : "stateDescription",
    "clusterState" : {
      "totalEntryCount" : 0,
      "scope" : "scope",
      "state" : [ {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      }, {
        "clusterNodeId" : "clusterNodeId",
        "clusterNodeAddress" : "clusterNodeAddress",
        "value" : "value",
        "key" : "key"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ComponentStateEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /connectors/{id}/assets
Creates a new Asset in the given Connector (createAsset)
This endpoint will create a new Asset in the Connector. The Asset will be created with the given name and the contents of the file that is uploaded.

Path parameters

id (required)
Path Parameter

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body object (required)
Body Parameter — The contents of the asset

Request headers

Filename (optional)
Header Parameter

Query parameters

Return type

AssetEntity

Example data

Content-Type: application/json
{
  "asset" : {
    "missingContent" : true,
    "digest" : "digest",
    "name" : "name",
    "id" : "id"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

AssetEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /connectors
Creates a new connector (createConnector)

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body ConnectorEntity (required)
Body Parameter — The connector configuration details.

Query parameters

Return type

ConnectorEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "availableActions" : [ {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    }, {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    } ],
    "configurationUrl" : "configurationUrl",
    "detailsUrl" : "detailsUrl",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "activeConfiguration" : {
      "configurationStepConfigurations" : [ {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      }, {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      } ]
    },
    "type" : "type",
    "managedProcessGroupId" : "managedProcessGroupId",
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "position" : {
      "x" : 0.8008281904610115,
      "y" : 6.027456183070403
    },
    "state" : "RUNNING",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "validationStatus"
  },
  "id" : "id",
  "uri" : "uri",
  "operatePermissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "status" : {
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "idleDuration" : "idleDuration",
      "groupId" : "groupId",
      "queued" : "queued",
      "idleDurationMillis" : 2,
      "type" : "type",
      "flowFilesReceived" : 9,
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesSent" : 3,
      "id" : "id",
      "written" : "written",
      "runStatus" : "runStatus",
      "bytesQueued" : 6,
      "bytesWritten" : 2,
      "read" : "read",
      "activeThreadCount" : 0,
      "idle" : true,
      "bytesRead" : 1,
      "processingPerformanceStatus" : {
        "identifier" : "identifier",
        "cpuDuration" : 1,
        "contentReadDuration" : 4,
        "sessionCommitDuration" : 1,
        "garbageCollectionDuration" : 1,
        "contentWriteDuration" : 7
      },
      "received" : "received",
      "bytesSent" : 5,
      "sent" : "sent",
      "bytesReceived" : 5,
      "flowFilesQueued" : 7,
      "name" : "name"
    },
    "id" : "id",
    "type" : "type",
    "statsLastRefreshed" : "statsLastRefreshed",
    "validationStatus" : "VALID",
    "runStatus" : "runStatus"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

ConnectorEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
post /connectors/{id}/purge-requests
Creates a request to purge the FlowFiles for this connector (createPurgeRequest)
This will create a request to purge all FlowFiles from the connector. The connector must be in a STOPPED state before purging can begin. This is an asynchronous operation. The client should poll the returned URI to get the status of the purge request.

Path parameters

id (required)
Path Parameter — The connector id.

Query parameters

Return type

DropRequestEntity

Example data

Content-Type: application/json
{
  "dropRequest" : {
    "percentCompleted" : 7,
    "original" : "original",
    "dropped" : "dropped",
    "droppedCount" : 1,
    "finished" : true,
    "uri" : "uri",
    "submissionTime" : "submissionTime",
    "currentSize" : 6,
    "lastUpdated" : "lastUpdated",
    "current" : "current",
    "droppedSize" : 5,
    "currentCount" : 0,
    "failureReason" : "failureReason",
    "originalCount" : 5,
    "id" : "id",
    "state" : "state",
    "originalSize" : 2
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

202

The request has been accepted. A HTTP response header will contain the URI where the response can be polled. DropRequestEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /connectors/{id}/configuration-steps/{configurationStepName}/verify-config/{requestId}
Deletes the Verification Request with the given ID (deleteConfigurationStepVerificationRequest)
Deletes the Verification Request with the given ID. After a request is created, it is expected that the client will properly clean up the request by DELETE'ing it, once the Verification process has completed. If the request is deleted before the request completes, then the Verification request will finish the step that it is currently performing and then will cancel any subsequent steps.

Path parameters

id (required)
Path Parameter — The connector id.
configurationStepName (required)
Path Parameter — The configuration step name.
requestId (required)
Path Parameter — The ID of the Verification Request

Query parameters

Return type

VerifyConnectorConfigStepRequestEntity

Example data

Content-Type: application/json
{
  "request" : {
    "percentCompleted" : 0,
    "connectorId" : "connectorId",
    "configurationStep" : {
      "configurationStepName" : "configurationStepName",
      "propertyGroupConfigurations" : [ {
        "propertyGroupDescription" : "propertyGroupDescription",
        "propertyGroupName" : "propertyGroupName",
        "propertyValues" : {
          "key" : {
            "secretName" : "secretName",
            "secretProviderId" : "secretProviderId",
            "secretProviderName" : "secretProviderName",
            "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
            "valueType" : "valueType",
            "value" : "value",
            "assetReferences" : [ {
              "missingContent" : true,
              "name" : "name",
              "id" : "id"
            }, {
              "missingContent" : true,
              "name" : "name",
              "id" : "id"
            } ]
          }
        },
        "propertyDescriptors" : {
          "key" : {
            "allowableValuesFetchable" : true,
            "allowableValues" : [ {
              "canRead" : true,
              "allowableValue" : {
                "displayName" : "displayName",
                "description" : "description",
                "value" : "value"
              }
            }, {
              "canRead" : true,
              "allowableValue" : {
                "displayName" : "displayName",
                "description" : "description",
                "value" : "value"
              }
            } ],
            "defaultValue" : "defaultValue",
            "name" : "name",
            "description" : "description",
            "type" : "type",
            "required" : true,
            "dependencies" : [ {
              "dependentValues" : [ "dependentValues", "dependentValues" ],
              "propertyName" : "propertyName"
            }, {
              "dependentValues" : [ "dependentValues", "dependentValues" ],
              "propertyName" : "propertyName"
            } ]
          }
        }
      }, {
        "propertyGroupDescription" : "propertyGroupDescription",
        "propertyGroupName" : "propertyGroupName",
        "propertyValues" : {
          "key" : {
            "secretName" : "secretName",
            "secretProviderId" : "secretProviderId",
            "secretProviderName" : "secretProviderName",
            "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
            "valueType" : "valueType",
            "value" : "value",
            "assetReferences" : [ {
              "missingContent" : true,
              "name" : "name",
              "id" : "id"
            }, {
              "missingContent" : true,
              "name" : "name",
              "id" : "id"
            } ]
          }
        },
        "propertyDescriptors" : {
          "key" : {
            "allowableValuesFetchable" : true,
            "allowableValues" : [ {
              "canRead" : true,
              "allowableValue" : {
                "displayName" : "displayName",
                "description" : "description",
                "value" : "value"
              }
            }, {
              "canRead" : true,
              "allowableValue" : {
                "displayName" : "displayName",
                "description" : "description",
                "value" : "value"
              }
            } ],
            "defaultValue" : "defaultValue",
            "name" : "name",
            "description" : "description",
            "type" : "type",
            "required" : true,
            "dependencies" : [ {
              "dependentValues" : [ "dependentValues", "dependentValues" ],
              "propertyName" : "propertyName"
            }, {
              "dependentValues" : [ "dependentValues", "dependentValues" ],
              "propertyName" : "propertyName"
            } ]
          }
        }
      } ],
      "configurationStepDescription" : "configurationStepDescription",
      "documented" : true,
      "dependencies" : [ {
        "dependentValues" : [ "dependentValues", "dependentValues" ],
        "propertyName" : "propertyName",
        "stepName" : "stepName"
      }, {
        "dependentValues" : [ "dependentValues", "dependentValues" ],
        "propertyName" : "propertyName",
        "stepName" : "stepName"
      } ]
    },
    "uri" : "uri",
    "submissionTime" : "2000-01-23T04:56:07.000+00:00",
    "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
    "configurationStepName" : "configurationStepName",
    "requestId" : "requestId",
    "updateSteps" : [ {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    }, {
      "failureReason" : "failureReason",
      "description" : "description",
      "complete" : true
    } ],
    "failureReason" : "failureReason",
    "state" : "state",
    "complete" : true,
    "results" : [ {
      "subject" : "subject",
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL"
    }, {
      "subject" : "subject",
      "verificationStepName" : "verificationStepName",
      "explanation" : "explanation",
      "outcome" : "SUCCESSFUL"
    } ]
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VerifyConnectorConfigStepRequestEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /connectors/{id}
Deletes a connector (deleteConnector)

Path parameters

id (required)
Path Parameter — The connector id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

ConnectorEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "availableActions" : [ {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    }, {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    } ],
    "configurationUrl" : "configurationUrl",
    "detailsUrl" : "detailsUrl",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "activeConfiguration" : {
      "configurationStepConfigurations" : [ {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      }, {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      } ]
    },
    "type" : "type",
    "managedProcessGroupId" : "managedProcessGroupId",
    "versionedComponentId" : "versionedComponentId",
    "name" : "name",
    "validationErrors" : [ "validationErrors", "validationErrors" ],
    "id" : "id",
    "position" : {
      "x" : 0.8008281904610115,
      "y" : 6.027456183070403
    },
    "state" : "RUNNING",
    "bundle" : {
      "artifact" : "artifact",
      "version" : "version",
      "group" : "group"
    },
    "validationStatus" : "validationStatus"
  },
  "id" : "id",
  "uri" : "uri",
  "operatePermissions" : {
    "canRead" : true,
    "canWrite" : true
  },
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 2
  },
  "status" : {
    "groupId" : "groupId",
    "name" : "name",
    "nodeSnapshots" : [ {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    }, {
      "address" : "address",
      "apiPort" : 6,
      "nodeId" : "nodeId"
    } ],
    "aggregateSnapshot" : {
      "idleDuration" : "idleDuration",
      "groupId" : "groupId",
      "queued" : "queued",
      "idleDurationMillis" : 2,
      "type" : "type",
      "flowFilesReceived" : 9,
      "queuedCount" : "queuedCount",
      "queuedSize" : "queuedSize",
      "flowFilesSent" : 3,
      "id" : "id",
      "written" : "written",
      "runStatus" : "runStatus",
      "bytesQueued" : 6,
      "bytesWritten" : 2,
      "read" : "read",
      "activeThreadCount" : 0,
      "idle" : true,
      "bytesRead" : 1,
      "processingPerformanceStatus" : {
        "identifier" : "identifier",
        "cpuDuration" : 1,
        "contentReadDuration" : 4,
        "sessionCommitDuration" : 1,
        "garbageCollectionDuration" : 1,
        "contentWriteDuration" : 7
      },
      "received" : "received",
      "bytesSent" : 5,
      "sent" : "sent",
      "bytesReceived" : 5,
      "flowFilesQueued" : 7,
      "name" : "name"
    },
    "id" : "id",
    "type" : "type",
    "statsLastRefreshed" : "statsLastRefreshed",
    "validationStatus" : "VALID",
    "runStatus" : "runStatus"
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

ConnectorEntity

400

NiFi was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

The request was valid but NiFi was not in the appropriate state to process it.

Up
delete /connectors/{id}/working-configuration
Discards the working configuration of a connector (discardConnectorUpdate)
This will discard any pending configuration changes for the connector and revert to the last applied configuration.

Path parameters

id (required)
Path Parameter — The connector id.

Query parameters

version (optional)
Query Parameter — The revision is used to verify the client is working with the latest version of the flow.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.
disconnectedNodeAcknowledged (optional)
Query Parameter — Acknowledges that this node is disconnected to allow for mutable requests to proceed. default: false

Return type

ConnectorEntity

Example data

Content-Type: application/json
{
  "bulletins" : [ {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  }, {
    "sourceId" : "sourceId",
    "canRead" : true,
    "groupId" : "groupId",
    "timestampIso" : "timestampIso",
    "id" : 5,
    "nodeAddress" : "nodeAddress",
    "bulletin" : {
      "sourceId" : "sourceId",
      "level" : "level",
      "sourceType" : "sourceType",
      "groupId" : "groupId",
      "timestampIso" : "timestampIso",
      "id" : 1,
      "sourceName" : "sourceName",
      "stackTrace" : "stackTrace",
      "category" : "category",
      "message" : "message",
      "nodeAddress" : "nodeAddress",
      "timestamp" : "timestamp"
    },
    "timestamp" : "timestamp"
  } ],
  "disconnectedNodeAcknowledged" : true,
  "component" : {
    "availableActions" : [ {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    }, {
      "allowed" : true,
      "name" : "name",
      "description" : "description",
      "reasonNotAllowed" : "reasonNotAllowed"
    } ],
    "configurationUrl" : "configurationUrl",
    "detailsUrl" : "detailsUrl",
    "parentGroupId" : "parentGroupId",
    "multipleVersionsAvailable" : true,
    "extensionMissing" : true,
    "activeConfiguration" : {
      "configurationStepConfigurations" : [ {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        } ],
        "configurationStepDescription" : "configurationStepDescription",
        "documented" : true,
        "dependencies" : [ {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        }, {
          "dependentValues" : [ "dependentValues", "dependentValues" ],
          "propertyName" : "propertyName",
          "stepName" : "stepName"
        } ]
      }, {
        "configurationStepName" : "configurationStepName",
        "propertyGroupConfigurations" : [ {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
          "propertyDescriptors" : {
            "key" : {
              "allowableValuesFetchable" : true,
              "allowableValues" : [ {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              }, {
                "canRead" : true,
                "allowableValue" : {
                  "displayName" : "displayName",
                  "description" : "description",
                  "value" : "value"
                }
              } ],
              "defaultValue" : "defaultValue",
              "name" : "name",
              "description" : "description",
              "type" : "type",
              "required" : true,
              "dependencies" : [ {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              }, {
                "dependentValues" : [ "dependentValues", "dependentValues" ],
                "propertyName" : "propertyName"
              } ]
            }
          }
        }, {
          "propertyGroupDescription" : "propertyGroupDescription",
          "propertyGroupName" : "propertyGroupName",
          "propertyValues" : {
            "key" : {
              "secretName" : "secretName",
              "secretProviderId" : "secretProviderId",
              "secretProviderName" : "secretProviderName",
              "fullyQualifiedSecretName" : "fullyQualifiedSecretName",
              "valueType" : "valueType",
              "value" : "value",
              "assetReferences" : [ {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              }, {
                "missingContent" : true,
                "name" : "name",
                "id" : "id"
              } ]
            }
          },
[...]
